const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const import_sources = sequelize.define(
    'import_sources',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

source_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"csv",


"xls",


"xlsx"

        ],

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

is_default: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  import_sources.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity









    db.import_sources.hasMany(db.file_uploads, {
      as: 'file_uploads_source',
      foreignKey: {
          name: 'sourceId',
      },
      constraints: false,
    });
















//end loop



    db.import_sources.belongsTo(db.tenants, {
      as: 'tenant',
      foreignKey: {
        name: 'tenantId',
      },
      constraints: false,
    });

    db.import_sources.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.import_sources.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.import_sources.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return import_sources;
};


